#define EXTERN
 
/*-------------------------
**  Standard include files
**-------------------------
*/
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
 
/*------------------------------
**  Non-standard include files
**------------------------------
*/
 
#include "ir1.h"
 
/*-------------------------------------------------------------------
**   filename_from_path () - extracts the file name portion from a
**           full pathname.
**-------------------------------------------------------------------
*/
void filename_from_path( 
	char *filename,   // output: filename here
	char *pathname,   //  input: pathname
	int filename_size 
)
{
   char * slash,
        * start;
   char buf[80];
 
   /* initialize to null */
   *filename = 0;
 
   /* find last '/' in path */
   if( NULL == (slash = strrchr( pathname, '/')) )
      start = pathname;
   else
      start = slash+1;
 
   /* copy filename to user. We copy to local variable buf just in case
      the destination filename is the same or overlaps the pathname. */
   strxcpy( buf, start, filename_size);
   strcpy(  filename, buf);
}

